#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>


#ifdef WIN32
	#include <winsock.h>
	#include <windows.h>
	#include <iphlpapi.h>
#define SHUT_WR	SD_SEND
//	#include <ws2tcpip.h>
#else
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <netdb.h>
	#include <unistd.h>
	#include <linux/if.h>
	#include <linux/sockios.h>
	#define closesocket close
#define _O_BINARY 0
#endif
/*
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/time.h>
#include <pthread.h>
*/
#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <pthread.h>

#include <sys/types.h>
#include <stdlib.h>
#include <dirent.h>


#define INT64 long long
#define UNS64 unsigned long long
#define UNS32 unsigned int

extern UNS64 wwwTime;
extern char HomePath[];
extern char * pabdir;
extern UNS32 NPort;

#define BID2EX 5
#define BIDSIZE  (1<<BID2EX)
#define BIDMASK (BIDSIZE-1)

typedef struct {
 UNS32 pass;
 UNS64 cost;
 UNS32 nn;
 char  FileName[128];
} BidTipe ;

 BidTipe BidTab[BIDSIZE];
 UNS32 BidCount;

UNS64 TimeCounter();
void accrualn( UNS32 nn, UNS64 account);
int drawaln( UNS32 nn, UNS64 account);


void BidInit()
{  int ii;
 for(ii=0;ii<BIDSIZE;ii++)
 {  BidTab[ii].pass=ii; BidTab[ii].cost=0; BidTab[ii].FileName[0]=0;  }
}

void sendp(int fd,char * cc)
{	send(fd,cc,strlen(cc),0);
}

int strss(char * dst, char * src )
{
	strcpy(dst,src);
	return strlen(src);
}


extern UNS64 FBiteCost;

int BidExec(char * FileN,UNS32 nn)
{
	char flname[256];
	struct stat stbuf;
	UNS64 cost;
  while(BidTab[BidCount].cost) BidCount=(BidCount+1)&BIDMASK ;
	strcpy(flname,HomePath);
	strcat(flname,pabdir); strcat(flname,"/");
	strcat(flname,FileN);

	if(stat(flname, &stbuf)) return -1;
	cost=stbuf.st_size*FBiteCost;
	BidTab[BidCount].cost=cost;
	BidTab[BidCount].nn=nn;
	printf("nnset=%d,%d\n",nn,BidCount);
    strcpy(BidTab[BidCount].FileName,FileN);

 return BidTab[BidCount].pass+=(0x1<<(BID2EX+1));
}


void webserver()
{  int fd, oldfd=0, id,zzz,fp;
DIR *dir;
struct dirent *entry;
char dirname[256];
char iobuf[9999];
char lh[99];
char flname[299];
char * pfnb;
char * pfnc;
char * pfne;
char * pdn;
  int sock=c_serv(NPort+100);

  BidInit();

  for(;;)
 {
	  fd = www_accept(sock);

 recv(fd,iobuf,98,0);
 iobuf[98]='/';
 iobuf[99]=0;
 printf("\n Received:<%s>\n",iobuf);
 pfnb=&iobuf;

	strcpy(dirname,HomePath);
	strcat(dirname,pabdir);

 while( *++pfnb != '/' );
 pfne=pfnc=&dirname[strlen(dirname)];
 while( *pfnb > ' ' ) *pfnc++=*pfnb++ ;
 *pfnc=0;
  write(1,"\npfnb=",6);
  write(1,dirname,strlen(dirname));

  pdn=&dirname[strlen(dirname)];
  while ( *--pdn != '/');
  pdn++;

 iobuf[0]=0;
 if(!*pdn)
 {
		fp=open("html0.txt",O_RDONLY|_O_BINARY,S_IRUSR | S_IWUSR );
		if(fp>0)
		{
		bzero(&iobuf[strlen(iobuf)],9301);
		read(fp,&iobuf[strlen(iobuf)],9300);
		close(fp);
		}
 }
 if(*pdn=='$')
 {  INT64 xxx; UNS64 TimeC; float yyy;  int mnumber;
	mnumber=atoi(++pdn);
	TimeC=TimeCounter();
	xxx=(TimeC-wwwTime);
	if( (xxx) > 0 )
	{
		accrualn(mnumber,xxx);
		wwwTime=TimeCounter()+60000000;
//		wwwIPAddr=f_struct[t_ii].CIPAddr;
		strcat(iobuf,"<H1><pre>Клиенту с N ");
		bzero(&iobuf[strlen(iobuf)],9);
		yyy=xxx;
		yyy*=1e-15;
		sprintf(lh,"%d\tвыплачено %e btc за клик\n",mnumber,yyy);
		strcat(iobuf,lh);
		fp=open("html1.txt",O_RDONLY|_O_BINARY,S_IRUSR | S_IWUSR );
		if(fp>0)
		{
		bzero(&iobuf[strlen(iobuf)],9301);
		read(fp,&iobuf[strlen(iobuf)],9300);
		close(fp);
		}
	}
	else{ strcat(iobuf,"<H1><pre>не прошло минуты с последней выплаты (не обязательно вам)\nосталось");
		sprintf(lh,"%lld сек",xxx/(1000000));
		strcat(iobuf,lh);
	}

	strcat(iobuf,"\n</pre></H1>");

	*--pdn=0;
 }
 if(pfne[1]==',')
 {	int pass; int LSock;
	LSock=s_open(8880,"localhost");
	if(1)
	{   char cc; int flg=0; int len=0;
 
		sendp(LSock,"s\" callback.4\" included ' ABORT TO ACCERR\n");
		sendp(LSock," BOOKING ");
		sendp(LSock,&pfne[2]);
		sendp(LSock," \n");
		sendp(LSock,"NBYE\n");
		sendp(LSock,"BYE\n");

		bzero(iobuf,9301);

		len+=strss(&iobuf[len], "HTTP/1.1 303 See Other\nLocation: http://");
		while(recv(LSock,&cc,1,0))
		{  //             write(1,&cc,1);
			  if(cc=='&') flg=1;
			  else if(cc=='#') {flg=1; len+=strss(&iobuf[len],":8980/&"); }
			  else if(cc==' ')  flg=0;
			  else if(flg) iobuf[len++]=cc;
		}
		iobuf[len++]='/';
		len+=strss(&iobuf[len],pdn);
		len+=strss(&iobuf[len],"\nContent-Length: 0\nConnection: close\n\n");
		write(1,&iobuf,len);
		send(fd,&iobuf,len,0);
	}
	else
	{
	}
 }

 if(pfne[1]=='&')
 {   char anum[11];
    char * panum;
    char * pnum;
   UNS32 pass;
   UNS32 BidCnt;
   
   pfne[2+10]='/';
  pnum = &pfne[2];
  panum = anum;
  
 while( *pnum != '/' ) *panum++=*pnum++ ;
 *panum=0;

	pass=atoi(anum);
	BidCnt=pass&BIDMASK;
	pfne[1]=0;
	strcat(dirname,BidTab[BidCnt].FileName);

//	 fp = open("Makefile", O_RDONLY);
	 fp = open(dirname, O_RDONLY|_O_BINARY,S_IRUSR | S_IWUSR );
	printf("\ndirname=%s %d\n",dirname,fp);
			if (fp != -1)
			{	struct stat sb;  int count;
				if(  drawaln(BidTab[BidCnt].nn,BidTab[BidCnt].cost) )
				{ strcat(iobuf,"<h1><pre>нахавтает средств на приобретение файла\n");
				  strcat(iobuf,"пополненить счет можно ");
				  strcat(iobuf,"<A HREF=\"http://");
				{ UNS32 myip=getmyip();
					sprintf(&iobuf[strlen(iobuf)] ,"%d.",myip&0xFF); myip>>=8;
					sprintf(&iobuf[strlen(iobuf)] ,"%d.",myip&0xFF); myip>>=8;
					sprintf(&iobuf[strlen(iobuf)] ,"%d.",myip&0xFF); myip>>=8;
					sprintf(&iobuf[strlen(iobuf)] ,"%d:8980/$",myip&0xFF);
					
				}
	printf("nnget=%d,%d\n",BidTab[BidCnt].nn,BidCnt);
				  sprintf(&iobuf[strlen(iobuf)],"%d",BidTab[BidCnt].nn);
				  strcat(iobuf,"\"> кликами</A></pre></h1>");
				}else
				{
				fstat(fp, &sb);
				strcpy(iobuf,"HTTP/1.1 200 OK\nContent-Type: multipart/*\nConnection: close\nContent-Length: ");
				sprintf(&iobuf[strlen(iobuf)] ,"%d\n\n",sb.st_size);
				send(fd,&iobuf,strlen(iobuf),0);
				write(1,&iobuf,strlen(iobuf));
				BidTab[BidCnt].cost=0;
				while ((count  = read(fp,&iobuf,sizeof(iobuf))) > 0) {
					if (count != send(fd,&iobuf,count,0) )	break;	}
#ifdef WIN32
				usleep(10000);
#endif
				pfne[1]=',';
				}
				close(fp);
			}


//	strcat(iobuf,"<pre>");
//	strcat(iobuf,"не хватает средств");
//	strcat(iobuf,"</pre>");
 }
 else
 {
	if(!*pdn)
	{
		fp=open("html.txt",O_RDONLY|_O_BINARY,S_IRUSR | S_IWUSR );
		if(fp>0)
		{
		bzero(&iobuf[strlen(iobuf)],9301);
		read(fp,&iobuf[strlen(iobuf)],9300);
		close(fp);
		}

	}

	if (dir = opendir(dirname))
	{ // entry = readdir(dir); //
		strcat(iobuf,"бесплатный просмотр первых 300 байт файлов<br>");
		strcat(iobuf,"<br><table><tr><td>");

	while ( (entry = readdir(dir)) != NULL)
	   {
		struct stat stbuf;
		if(entry->d_name[0]!='.')
		{	strcpy(flname,dirname);
			strcat(flname,"/");
			strcat(flname,entry->d_name);
		 if(stat(flname, &stbuf)==0)
		 {
			strcat(iobuf,"</td></tr><tr><td><A HREF=\"");
			strcat(iobuf,pdn);
			strcat(iobuf,"/");
			strcat(iobuf,entry->d_name);
			strcat(iobuf,"\">");

			if( (stbuf.st_mode & S_IFMT) == S_IFDIR ) strcat(iobuf,"/");
			strcat(iobuf,entry->d_name);
			strcat(iobuf,"</a>");

			strcat(iobuf,"</td><td>_ ");

			sprintf(lh,"%d\t",stbuf.st_size);
			strcat(iobuf,lh);

			strcat(iobuf,"</td><td>_ ");

			strcat(iobuf, ctime(&stbuf.st_mtime));

		 	iobuf[strlen(iobuf)-1]=' ';

			if( (stbuf.st_mode & S_IFMT) != S_IFDIR )
			{
			strcat(iobuf,"</td><td>_<A HREF=\"http://localhost:8980/");
			sprintf(lh,",%u,%u",getmyip(),NPort);
			strcat(iobuf,lh);
			if(*pfne)
			{
			strcat(iobuf,pfne);
			strcat(iobuf,"/");
			}
			strcat(iobuf,entry->d_name);
			strcat(iobuf,"\">покупка");
			strcat(iobuf,"</a>");
			}

			strcat(iobuf,"\n");
		 }
		}
	   }
	    closedir(dir);
	}
	else
	{
		fp=open(dirname,O_RDONLY|_O_BINARY,S_IRUSR | S_IWUSR );
		printf("\nDirname=%s %d\n",dirname,fp);
		if(fp>0)
		{
			strcat(iobuf,"<pre>");
			bzero(&iobuf[strlen(iobuf)],301);
			read(fp,&iobuf[strlen(iobuf)],300);
			close(fp);
			strcat(iobuf,"</pre>");
		}
	}
 } // else

//	 	printf(iobuf);	 	printf("\n");
 if(pfne[1]!=',')
 {
	sendp(fd,"HTTP/1.1 200 OK\nContent-length: ");
	sprintf(lh,"%d",strlen(iobuf)+27);
	write(1,&lh,strlen(lh));
	send(fd,&lh,strlen(lh),0);
	sendp(fd,"\nContent-Language: ru\nContent-type: text/html; charset=utf-8\n\n<HTML><BODY>");

	send(fd,&iobuf,strlen(iobuf),0);
	send(fd,"</BODY></HTML>.....",17,0);
 }
 shutdown(fd, SHUT_WR);
 recv(fd,&iobuf,strlen(iobuf),0);
 closesocket(fd);
// if(oldfd) closesocket(oldfd);
 oldfd=fd;

 } // for
}

//192.168.1.182
